<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="用户编号" prop="usercode">
        <el-input
          v-model="queryParams.usercode"
          placeholder="请输入用户编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="昵称" prop="nickname">
        <el-input
          v-model="queryParams.nickname"
          placeholder="请输入昵称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input
          v-model="queryParams.mobile"
          placeholder="请输入手机号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['xq:userInfoAudit:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="multiple"
          @click="handleAuditSuccess"
          v-hasPermi="['xq:userInfoAudit:edit']"
        >批量审核通过
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="userInfoAuditList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="用户编号" align="center" prop="usercode"/>
      <el-table-column label="昵称" align="center" prop="nickname" show-overflow-tooltip/>
      <el-table-column label="手机号" align="center" prop="mobile" width="100"/>
      <el-table-column label="头像" align="center" prop="avatar">
        <template v-slot="scope">
          <image-avatar :src="scope.row.avatar"/>
        </template>
      </el-table-column>
      <el-table-column label="类型" align="center" prop="infoType">
        <template v-slot="scope">
          <cai-dict-tag :options="userInfoAuditTypeList" :value="scope.row.infoType"/>
        </template>
      </el-table-column>
      <el-table-column label="内容" align="center" prop="auditContent">
        <template v-slot="scope">
          <image-avatar :src="scope.row.auditContent" v-if="scope.row.infoType === 1"/>
          <span v-if="scope.row.infoType === 2">{{ scope.row.auditContent }}</span>
        </template>
      </el-table-column>
      <el-table-column label="申请时间" align="center" prop="createTime" width="160"/>
      <el-table-column label="状态" align="center" prop="auditStatus">
        <template v-slot="scope">
          <cai-dict-tag :options="auditStatusList" :value="scope.row.auditStatus"/>
        </template>
      </el-table-column>
      <el-table-column label="审核备注" align="center" prop="auditRemark"/>
      <el-table-column label="审核时间" align="center" prop="auditTime" width="160"/>
      <el-table-column label="审核人" align="center" prop="auditOpName"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button
            size="mini"
            type="text"
            @click="handleAuditSuccess(scope.row)"
            v-if="scope.row.auditStatus === 1"
            v-hasPermi="['xq:userInfoAudit:edit']"
          >通过
          </el-button>
          <el-button
            size="mini"
            type="text"
            v-if="scope.row.auditStatus === 1"
            @click="handleAuditFail(scope.row)"
            v-hasPermi="['xq:userInfoAudit:edit']"
          >不通过
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['xq:userInfoAudit:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script>
import { delUserInfoAudit, listUserInfoAudit, userInfoAuditFail, userInfoAuditSuccess } from '@/api/xq/userInfoAudit'
import { auditStatusList, userInfoAuditTypeList } from '@/constant/statusMap'

export default {
  name: 'UserInfoAudit',
  data() {
    return {
      auditStatusList, userInfoAuditTypeList,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户信息审核表格数据
      userInfoAuditList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        usercode: undefined,
        nickname: undefined,
        auditStatus: undefined,
        mobile: undefined
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询用户信息审核列表 */
    getList() {
      this.loading = true
      listUserInfoAudit(this.queryParams).then(response => {
        this.userInfoAuditList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    handleAuditSuccess(row){
      const ids = row.id || this.ids.join(',')
      this.$modal.confirm('是否确认审核通过用户数据审核项？').then(() => {
        this.loading = true
        console.log(ids)
        return userInfoAuditSuccess({ 'ids': ids })
      }).then(() => {
        this.loading = false
        this.getList()
        this.$modal.msgSuccess('操作成功')
      }).catch(() => {
      }).finally(() => {
        this.loading = false
      })
    },
    handleAuditFail(row){
      this.$prompt('请输入失败原因', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputPattern: /^.+$/,
        inputErrorMessage: '失败原因必填',
        inputType: 'textarea'
      }).then(({ value }) => {
        this.loading = true
        return userInfoAuditFail({
          'auditRemark': value,
          'id': row.id
        })
      }).then(() => {
        this.loading = false
        this.getList()
        this.$modal.msgSuccess('审核成功')
      }).catch(() => {
      }).finally(() => {
        this.loading = false
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids
      this.$modal.confirm('是否确认删除用户信息审核编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true
        return delUserInfoAudit(ids)
      }).then(() => {
        this.loading = false
        this.getList()
        this.$modal.msgSuccess('删除成功')
      }).catch(() => {
      }).finally(() => {
        this.loading = false
      })
    }
  }
}
</script>
